import 'packets-general.dart' show PREFIX, zeros, POSTFIX, Packet;

const SYNC_PREFIX = '02000007';

Packet createTimeSyncPacket(String controllerId) {
  // The step is the difference between the sum of hour/minute/second and the syncPostfix (given as hex value) in the Wine program
  const step = 23;

  final date = DateTime.now();
  final year = date.year;
  final month = date.month;
  final day = date.day;
  final hour = date.hour;
  final minute = date.minute;
  final second = date.second;

  final syncPostfix =
      (hour + minute + second + step).toRadixString(16).padLeft(2, '0');

  final syncDate = year.toRadixString(16).padLeft(4, '0') +
      month.toRadixString(16).padLeft(2, '0') +
      day.toRadixString(16).padLeft(2, '0') +
      hour.toRadixString(16).padLeft(2, '0') +
      minute.toRadixString(16).padLeft(2, '0') +
      second.toRadixString(16).padLeft(2, '0');

  final data = PREFIX +
      SYNC_PREFIX +
      syncDate +
      zeros(86 - syncDate.length) +
      controllerId +
      syncPostfix +
      POSTFIX;

  return Packet(data, true);
}
